;*********************************************************
;* Moving and changing sprites by Christian Mortenson    *
;*********************************************************
#include "ti86asm.inc"
.org _asm_exec_ram

  call _clrScrn             ; Clear screen
  call _homeup            ; Cursor to top left
  ld de,$070B              ; d contains y, e contains x
  call PutPerson 
  ld b,10
  ld de,$0001         
Phase1:
  call WingsUp  
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call WingsMid 
  halt
  halt
  halt
  halt
  halt
  halt
 call WingsDown
  halt
  halt
  halt
  halt
  halt
  halt
  call Delete
  inc e
  push bc
  push de
  ld hl,Up					; hl points to start of sprite
  call GridPutSprite     	; Despliega Sprite
  pop de
  pop bc
  djnz Phase1
  ld b,2
Phase2:
  call WingsUp  
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call WingsMid
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call WingsDown  
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call Delete
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  dec e
  dec e
  inc d
  push bc
  push de
  ld hl,Up					  ; hl points to start of sprite
  call GridPutSprite    	  ; Draw smiley in top left
  pop de
  pop bc
  djnz Phase2
  ld b,4
Phase3:
  call WingsUp  
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call WingsMid
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
 call WingsDown
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call Delete
  inc e
  inc d
  push bc
  push de
  ld hl,Up						; hl points to start of sprite
  call GridPutSprite     		; Draw smiley in top left
  pop de
  pop bc
  djnz Phase3
  ld b,5
Phase4:
  
  call WingsUp  
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call WingsMid
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
 call WingsDown
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call WingsDown
  djnz Phase4
  ld de,$070B 
  ld b,15
Phase5:
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call PutPersonMove
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  halt
  call PutPerson  
  djnz Phase5
  ret                        		 ; Exit
Exit:
  ret
GridPutSprite:
  push af
  push hl            				 ; push hl to stack...                
  pop ix              				 ; ...and pop it into iy
  srl d                				 ; de = (128 * y) + x
  rra                   			 ; carry flag -< msb of a
  and $80              				 ; a is either $00 or $80   
  or e                  			 ; add x offset (remember x <= 15)
  ld e,a               				 ; de = (128 * y) + (x * 8)
  ld hl,$fc00         				 ; hl-> video memory
  add hl,de           				 ; hl-> video memory + offset
  ld b,8               				 ; initialize loop counter
  ld de,16            				 ; screen is 16 bytes wide
GPS_Loop:
  ld a,(ix + 0)        				 ; get byte from sprite
  ld (hl),a           				 ; put byte on screen
  inc ix              			     ; move to next byte in sprite
  add hl,de            				 ; move to next line on screen
  djnz GPS_Loop         		     ; loop until sprite is drawn
  pop af
  ret
WingsUp:
  push bc
  push de
  ld hl,Up						     ; hl points to start of sprite
  call GridPutSprite    			 ; Draw smiley in top left
  pop de
  pop bc
  ret                 				 ; return
WingsDown:
  push bc
  push de
  ld hl,Down 						 ; hl points to start of sprite
  call GridPutSprite    			 ; Draw smiley in top left
  pop de
  pop bc
  ret  

WingsMid:
  push bc
  push de
  ld hl,Down 						 ; hl points to start of sprite
  call GridPutSprite    			 ; Draw smiley in top left
  pop de
  pop bc
  ret  
Delete:
  push bc
  push de
  ld hl,SpriteVoid  				; hl points to start of sprite
  call GridPutSprite     			; Draw smiley in top left
  pop de
  pop bc
  ret
PutPerson:
  push bc
  push de
  ld hl,ArmsUp						 ; hl points to start of sprite
  call GridPutSprite    			 ; Draw smiley in top left
  pop de
  pop bc
  ret  
PutPersonMove:
  push bc
  push de
  ld hl,ArmsDown					  ; hl points to start of sprite
  call GridPutSprite    			  ; Draw smiley in top left
  pop de
  pop bc
  ret  

Up:
	.db %00000000
	.db %10000010
	.db %01000100
	.db %00101000
	.db %01010100
	.db %00111000
	.db %01010100
	.db %00000000
Mid:
	.db %00000000
	.db %00000000
	.db %10000010
	.db %01101100
	.db %01010100
	.db %00111000
	.db %01010100
	.db %00000000
Down:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %01101100
	.db %11010110
	.db %10111010
	.db %01010100
	.db %00000000

SpriteVoid:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

ArmsUp:
	.db %00011000
	.db %00100100
	.db %00011000
	.db %10111101
	.db %01011010
	.db %00011000
	.db %00011000
	.db %00111100
ArmsDown:
	.db %00011000
	.db %00100100
	.db %00011000
	.db %00111100
	.db %01011010
	.db %10011001
	.db %00011000
	.db %00111100
.end